# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from opencv_apps/Face.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import opencv_apps.msg

class Face(genpy.Message):
  _md5sum = "a1a50e747b0ca7822ce8611c3ffa7a02"
  _type = "opencv_apps/Face"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """Rect face
Rect[] eyes
string label
float64 confidence

================================================================================
MSG: opencv_apps/Rect
# opencv Rect data type, x-y is center point
float64 x
float64 y
float64 width
float64 height

"""
  __slots__ = ['face','eyes','label','confidence']
  _slot_types = ['opencv_apps/Rect','opencv_apps/Rect[]','string','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       face,eyes,label,confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Face, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.face is None:
        self.face = opencv_apps.msg.Rect()
      if self.eyes is None:
        self.eyes = []
      if self.label is None:
        self.label = ''
      if self.confidence is None:
        self.confidence = 0.
    else:
      self.face = opencv_apps.msg.Rect()
      self.eyes = []
      self.label = ''
      self.confidence = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_4d().pack(_x.face.x, _x.face.y, _x.face.width, _x.face.height))
      length = len(self.eyes)
      buff.write(_struct_I.pack(length))
      for val1 in self.eyes:
        _x = val1
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.width, _x.height))
      _x = self.label
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.confidence
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.face is None:
        self.face = opencv_apps.msg.Rect()
      if self.eyes is None:
        self.eyes = None
      end = 0
      _x = self
      start = end
      end += 32
      (_x.face.x, _x.face.y, _x.face.width, _x.face.height,) = _get_struct_4d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.eyes = []
      for i in range(0, length):
        val1 = opencv_apps.msg.Rect()
        _x = val1
        start = end
        end += 32
        (_x.x, _x.y, _x.width, _x.height,) = _get_struct_4d().unpack(str[start:end])
        self.eyes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.label = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.label = str[start:end]
      start = end
      end += 8
      (self.confidence,) = _get_struct_d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_4d().pack(_x.face.x, _x.face.y, _x.face.width, _x.face.height))
      length = len(self.eyes)
      buff.write(_struct_I.pack(length))
      for val1 in self.eyes:
        _x = val1
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.width, _x.height))
      _x = self.label
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.confidence
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.face is None:
        self.face = opencv_apps.msg.Rect()
      if self.eyes is None:
        self.eyes = None
      end = 0
      _x = self
      start = end
      end += 32
      (_x.face.x, _x.face.y, _x.face.width, _x.face.height,) = _get_struct_4d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.eyes = []
      for i in range(0, length):
        val1 = opencv_apps.msg.Rect()
        _x = val1
        start = end
        end += 32
        (_x.x, _x.y, _x.width, _x.height,) = _get_struct_4d().unpack(str[start:end])
        self.eyes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.label = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.label = str[start:end]
      start = end
      end += 8
      (self.confidence,) = _get_struct_d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
