# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from opencv_apps/FaceArray.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import opencv_apps.msg

class FaceArray(genpy.Message):
  _md5sum = "3ae7a36ff47d72f5dd1d764612b2b3c8"
  _type = "opencv_apps/FaceArray"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """Face[] faces


================================================================================
MSG: opencv_apps/Face
Rect face
Rect[] eyes
string label
float64 confidence

================================================================================
MSG: opencv_apps/Rect
# opencv Rect data type, x-y is center point
float64 x
float64 y
float64 width
float64 height

"""
  __slots__ = ['faces']
  _slot_types = ['opencv_apps/Face[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       faces

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FaceArray, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.faces is None:
        self.faces = []
    else:
      self.faces = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.faces)
      buff.write(_struct_I.pack(length))
      for val1 in self.faces:
        _v1 = val1.face
        _x = _v1
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.width, _x.height))
        length = len(val1.eyes)
        buff.write(_struct_I.pack(length))
        for val2 in val1.eyes:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.width, _x.height))
        _x = val1.label
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.confidence
        buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.faces is None:
        self.faces = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.faces = []
      for i in range(0, length):
        val1 = opencv_apps.msg.Face()
        _v2 = val1.face
        _x = _v2
        start = end
        end += 32
        (_x.x, _x.y, _x.width, _x.height,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.eyes = []
        for i in range(0, length):
          val2 = opencv_apps.msg.Rect()
          _x = val2
          start = end
          end += 32
          (_x.x, _x.y, _x.width, _x.height,) = _get_struct_4d().unpack(str[start:end])
          val1.eyes.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.label = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.label = str[start:end]
        start = end
        end += 8
        (val1.confidence,) = _get_struct_d().unpack(str[start:end])
        self.faces.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.faces)
      buff.write(_struct_I.pack(length))
      for val1 in self.faces:
        _v3 = val1.face
        _x = _v3
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.width, _x.height))
        length = len(val1.eyes)
        buff.write(_struct_I.pack(length))
        for val2 in val1.eyes:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.width, _x.height))
        _x = val1.label
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.confidence
        buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.faces is None:
        self.faces = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.faces = []
      for i in range(0, length):
        val1 = opencv_apps.msg.Face()
        _v4 = val1.face
        _x = _v4
        start = end
        end += 32
        (_x.x, _x.y, _x.width, _x.height,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.eyes = []
        for i in range(0, length):
          val2 = opencv_apps.msg.Rect()
          _x = val2
          start = end
          end += 32
          (_x.x, _x.y, _x.width, _x.height,) = _get_struct_4d().unpack(str[start:end])
          val1.eyes.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.label = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.label = str[start:end]
        start = end
        end += 8
        (val1.confidence,) = _get_struct_d().unpack(str[start:end])
        self.faces.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
